Bug 89319 - FILESAVE: redundant, slow file seeking during XLS export
Summary: FILESAVE: redundant, slow file seeking during XLS export
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.2.5.2 release
Hardware: Other All
: medium minor
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: filter:xls, haveBacktrace, perf
Depends on:
Blocks: XLS
  Show dependency treegraph
 
Reported: 2015-02-11 20:42 UTC by László Németh
Modified: 2019-04-24 11:39 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
kcachegrind profile - base (226.20 KB, image/png)
2015-02-13 09:25 UTC, László Németh
Details
kcachegrind profile - optimized (~3%) XLS export (216.12 KB, image/png)
2015-02-13 09:31 UTC, László Németh
Details
Perf flamegraph (160.79 KB, image/svg+xml)
2019-04-24 11:38 UTC, Buovjaga
Details

Note You need to log in before you can comment on or make changes to this bug.
Description László Németh 2015-02-11 20:42:47 UTC
Profiling and analysis of XLS export showed unnecessary and expensive file seekings.
Comment 1 Commit Notification 2015-02-11 21:08:01 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8e2293e06adba3f22e824acad99983fb5b997e4d

tdf#89319 remove redundant file seekings in XLS export

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 2 Commit Notification 2015-02-12 14:54:52 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=6547c93056cfa8cf60c0bb48d7eb50f81a560773

tdf#89319 SvFileStream: remove redundant osl_getFilePos() calls

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 3 László Németh 2015-02-13 09:25:56 UTC
Created attachment 113360 [details]
kcachegrind profile - base
Comment 4 László Németh 2015-02-13 09:31:55 UTC
Created attachment 113361 [details]
kcachegrind profile - optimized (~3%) XLS export
Comment 5 Commit Notification 2015-03-10 19:46:36 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=71b630e5b683b3761af9d6bdce56f13f20da84c1

replace an OSL_ENSURE() with assert(), tdf#89319 related

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2015-03-26 20:03:19 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4dfa19d61331bab284e188422fbc95baf814b602

Revert "tdf#89319 remove redundant file seekings in XLS export"

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 7 Eike Rathke 2015-03-26 20:04:40 UTC
Reverted, see commit message.
Comment 8 Robinson Tryon (qubit) 2015-03-31 15:33:33 UTC
(In reply to Eike Rathke from comment #7)
> Reverted, see commit message.

Nobody is currently assigned to this bug, so per criteria for Status 'REOPENED'
https://wiki.documentfoundation.org/QA/Bugzilla/Fields/Status/REOPENED#Criteria
Status -> NEW
Comment 9 tommy27 2016-04-16 07:28:49 UTC Comment hidden (obsolete)
Comment 10 QA Administrators 2017-05-22 13:27:00 UTC Comment hidden (obsolete)
Comment 11 Buovjaga 2019-04-24 11:38:46 UTC
Created attachment 150974 [details]
Perf flamegraph

1. Typed test into A1
2. Saved as XLS

Trace taken from saving phase.

Arch Linux 64-bit
Version: 6.3.0.0.alpha0+
Build ID: cfbb223d5666cb803539ac98918ff39b27efc6e7
CPU threads: 8; OS: Linux 5.0; UI render: default; VCL: gtk3; 
Locale: fi-FI (fi_FI.UTF-8); UI-Language: en-US
Calc: threaded
Built on 24 April 2019